@testitem "Aqua" tags = [:core] begin
    using Aqua, NonlinearSolveQuasiNewton

    Aqua.test_all(
        NonlinearSolveQuasiNewton;
        piracies = false, ambiguities = false, stale_deps = false, deps_compat = false
    )
    Aqua.test_stale_deps(NonlinearSolveQuasiNewton; ignore = [:SciMLJacobianOperators])
    Aqua.test_deps_compat(NonlinearSolveQuasiNewton; ignore = [:SciMLJacobianOperators])
    Aqua.test_piracies(NonlinearSolveQuasiNewton)
    Aqua.test_ambiguities(NonlinearSolveQuasiNewton; recursive = false)
end

@testitem "Explicit Imports" tags = [:core] begin
    using ExplicitImports, NonlinearSolveQuasiNewton

    @test check_no_implicit_imports(
        NonlinearSolveQuasiNewton; skip = (Base, Core, SciMLBase)
    ) === nothing
    @test check_no_stale_explicit_imports(NonlinearSolveQuasiNewton) === nothing
    @test check_all_qualified_accesses_via_owners(NonlinearSolveQuasiNewton) === nothing
end

"""
    Broyden(;
        max_resets::Int = 100, linesearch = nothing, reset_tolerance = nothing,
        init_jacobian::Val = Val(:identity), autodiff = nothing, alpha = nothing,
        update_rule = Val(:good_broyden)
    )

An implementation of `Broyden`'s Method [broyden1965class](@cite) with resetting and line
search.

### Keyword Arguments

  - `max_resets`: the maximum number of resets to perform. Defaults to `100`.

  - `reset_tolerance`: the tolerance for the reset check. Defaults to
    `sqrt(eps(real(eltype(u))))`.
  - `alpha`: If `init_jacobian` is set to `Val(:identity)`, then the initial Jacobian
    inverse is set to be `(αI)⁻¹`. Defaults to `nothing` which implies
    `α = max(norm(u), 1) / (2 * norm(fu))`.
  - `init_jacobian`: the method to use for initializing the jacobian. Defaults to
    `Val(:identity)`. Choices include:

      + `Val(:identity)`: Identity Matrix.
      + `Val(:true_jacobian)`: True Jacobian. This is a good choice for differentiable
        problems.
  - `update_rule`: Update Rule for the Jacobian. Choices are:

      + `Val(:good_broyden)`: Good Broyden's Update Rule
      + `Val(:bad_broyden)`: Bad Broyden's Update Rule
      + `Val(:diagonal)`: Only update the diagonal of the Jacobian. This algorithm may be
        useful for specific problems, but whether it will work may depend strongly on the
        problem
"""
function Broyden(;
        max_resets::Int = 100, linesearch = nothing, reset_tolerance = nothing,
        init_jacobian::Val = Val(:identity), autodiff = nothing, alpha = nothing,
        update_rule = Val(:good_broyden)
    )
    return QuasiNewtonAlgorithm(;
        linesearch,
        descent = NewtonDescent(),
        update_rule = broyden_update_rule(update_rule),
        max_resets,
        initialization = broyden_init(init_jacobian, update_rule, autodiff, alpha),
        reinit_rule = NoChangeInStateReset(; reset_tolerance),
        concrete_jac = Val(init_jacobian isa Val{:true_jacobian}),
        name = :Broyden
    )
end

function broyden_init(::Val{:identity}, ::Val{:diagonal}, autodiff, alpha)
    return IdentityInitialization(alpha, DiagonalStructure())
end
function broyden_init(::Val{:identity}, ::Val, autodiff, alpha)
    return IdentityInitialization(alpha, FullStructure())
end
function broyden_init(::Val{:true_jacobian}, ::Val, autodiff, alpha)
    return TrueJacobianInitialization(FullStructure(), autodiff)
end
function broyden_init(::Val{IJ}, ::Val{UR}, autodiff, alpha) where {IJ, UR}
    error("Unknown combination of `init_jacobian = Val($(Meta.quot(IJ)))` and \
           `update_rule = Val($(Meta.quot(UR)))`. Please choose a valid combination.")
end

broyden_update_rule(::Val{:good_broyden}) = GoodBroydenUpdateRule()
broyden_update_rule(::Val{:bad_broyden}) = BadBroydenUpdateRule()
broyden_update_rule(::Val{:diagonal}) = GoodBroydenUpdateRule()
function broyden_update_rule(::Val{UR}) where {UR}
    error("Unknown update rule `update_rule = Val($(Meta.quot(UR)))`. Please choose a \
           valid update rule.")
end

"""
    BadBroydenUpdateRule()

Broyden Update Rule corresponding to "bad broyden's method" [broyden1965class](@cite).
"""
struct BadBroydenUpdateRule <: AbstractApproximateJacobianUpdateRule end

"""
    GoodBroydenUpdateRule()

Broyden Update Rule corresponding to "good broyden's method" [broyden1965class](@cite).
"""
struct GoodBroydenUpdateRule <: AbstractApproximateJacobianUpdateRule end

for rType in (:BadBroydenUpdateRule, :GoodBroydenUpdateRule)
    @eval function Base.getproperty(rule::$(rType), sym::Symbol)
        sym == :store_inverse_jacobian && return Val(true)
        return getfield(rule, sym)
    end
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem,
        alg::Union{BadBroydenUpdateRule, GoodBroydenUpdateRule},
        J, fu, u, du, args...; internalnorm::F = L2_NORM, kwargs...
    ) where {F}
    @bb J⁻¹dfu = similar(u)
    @bb dfu = copy(fu)
    if alg isa GoodBroydenUpdateRule || J isa Diagonal
        @bb u_cache = similar(u)
    else
        u_cache = nothing
    end
    if J isa Diagonal
        du_cache = nothing
    else
        @bb du_cache = similar(du)
    end
    return BroydenUpdateRuleCache(J⁻¹dfu, dfu, u_cache, du_cache, internalnorm, alg)
end

@concrete mutable struct BroydenUpdateRuleCache <:
    AbstractApproximateJacobianUpdateRuleCache
    J⁻¹dfu
    dfu
    u_cache
    du_cache
    internalnorm
    rule <: Union{BadBroydenUpdateRule, GoodBroydenUpdateRule}
end

function InternalAPI.solve!(
        cache::BroydenUpdateRuleCache, J⁻¹, fu, u, du; kwargs...
    )
    T = eltype(u)
    @bb @. cache.dfu = fu - cache.dfu
    @bb cache.J⁻¹dfu = J⁻¹ × vec(cache.dfu)
    if cache.rule isa GoodBroydenUpdateRule
        @bb cache.u_cache = transpose(J⁻¹) × vec(du)
        denom = dot(du, cache.J⁻¹dfu)
        rmul = transpose(Utils.safe_vec(cache.u_cache))
    else
        denom = cache.internalnorm(cache.dfu)^2
        rmul = transpose(Utils.safe_vec(cache.dfu))
    end
    @bb @. cache.du_cache = (du - cache.J⁻¹dfu) / ifelse(iszero(denom), T(1.0e-5), denom)
    @bb J⁻¹ += vec(cache.du_cache) × rmul
    @bb copyto!(cache.dfu, fu)
    return J⁻¹
end

function InternalAPI.solve!(
        cache::BroydenUpdateRuleCache, J⁻¹::Diagonal, fu, u, du; kwargs...
    )
    T = eltype(u)
    @bb @. cache.dfu = fu - cache.dfu
    J⁻¹_diag = Utils.restructure(cache.dfu, diag(J⁻¹))
    if cache.rule isa GoodBroydenUpdateRule
        @bb @. cache.J⁻¹dfu = J⁻¹_diag * cache.dfu * du
        denom = sum(cache.J⁻¹dfu)
        @bb @. J⁻¹_diag += (du - cache.J⁻¹dfu) * du * J⁻¹_diag /
            ifelse(iszero(denom), T(1.0e-5), denom)
    else
        denom = cache.internalnorm(cache.dfu)^2
        @bb @. J⁻¹_diag += (du - J⁻¹_diag * cache.dfu) * cache.dfu /
            ifelse(iszero(denom), T(1.0e-5), denom)
    end
    @bb copyto!(cache.dfu, fu)
    return Diagonal(vec(J⁻¹_diag))
end

"""
    InitializedApproximateJacobianCache(
        J, structure, alg, cache, initialized::Bool, internalnorm
    )

A cache for Approximate Jacobian.

### Arguments

  - `J`: The current Jacobian.
  - `structure`: The structure of the Jacobian.
  - `alg`: The initialization algorithm.
  - `cache`: The Jacobian cache [`NonlinearSolveBase.construct_jacobian_cache`](@ref)
    (if needed).
  - `initialized`: A boolean indicating whether the Jacobian has been initialized.
  - `internalnorm`: The norm to be used.

### Interface

```julia
(cache::InitializedApproximateJacobianCache)(::Nothing)
```

Returns the current Jacobian `cache.J` with the proper `structure`.

```julia
InternalAPI.solve!(cache::InitializedApproximateJacobianCache, fu, u, ::Val{reinit})
```

Solves for the Jacobian `cache.J` and returns it. If `reinit` is `true`, then the Jacobian
is reinitialized.
"""
@concrete mutable struct InitializedApproximateJacobianCache <: AbstractJacobianCache
    J
    structure
    alg
    cache
    initialized::Bool
    internalnorm
end

function InternalAPI.reinit_self!(cache::InitializedApproximateJacobianCache; kwargs...)
    return cache.initialized = false
end

NonlinearSolveBase.@internal_caches InitializedApproximateJacobianCache :cache

function (cache::InitializedApproximateJacobianCache)(::Nothing)
    return NonlinearSolveBase.get_full_jacobian(cache, cache.structure, cache.J)
end

function InternalAPI.solve!(
        cache::InitializedApproximateJacobianCache, fu, u, reinit::Val
    )
    if reinit isa Val{true} || !cache.initialized
        cache(cache.alg, fu, u)
        cache.initialized = true
    end
    if NonlinearSolveBase.stores_full_jacobian(cache.structure)
        full_J = cache.J
    else
        full_J = NonlinearSolveBase.get_full_jacobian(cache, cache.structure, cache.J)
    end
    return full_J
end

"""
    IdentityInitialization(alpha, structure)

Initialize the Jacobian to be an Identity Matrix scaled by `alpha` and maintain the
structure as specified by `structure`.
"""
@concrete struct IdentityInitialization <: AbstractJacobianInitialization
    alpha
    structure
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem, alg::IdentityInitialization, solver, f::F,
        fu, u, p; internalnorm::IN = L2_NORM, kwargs...
    ) where {F, IN}
    α = Utils.initial_jacobian_scaling_alpha(alg.alpha, u, fu, internalnorm)
    if u isa Number
        J = α
    else
        if alg.structure isa DiagonalStructure
            @assert length(u) == length(fu) "Diagonal Jacobian Structure must be square!"
            J = one.(Utils.safe_vec(fu)) .* α
        else
            # A simple trick to get the correct jacobian structure
            J = alg.structure(Utils.make_identity!!(vec(fu) * vec(u)', α); alias = true)
        end
    end
    return InitializedApproximateJacobianCache(
        J, alg.structure, alg, nothing, true, internalnorm
    )
end

function (cache::InitializedApproximateJacobianCache)(
        alg::IdentityInitialization, fu, u
    )
    α = Utils.initial_jacobian_scaling_alpha(alg.alpha, u, fu, cache.internalnorm)
    cache.J = Utils.make_identity!!(cache.J, α)
    return
end

"""
    TrueJacobianInitialization(structure, autodiff)

Initialize the Jacobian to be the true Jacobian and maintain the structure as specified
by `structure`. `autodiff` is used to compute the true Jacobian and if not specified we
make a selection automatically.
"""
@concrete struct TrueJacobianInitialization <: AbstractJacobianInitialization
    structure
    autodiff
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem, alg::TrueJacobianInitialization,
        solver, f::F, fu, u, p; stats, linsolve = missing,
        internalnorm::IN = L2_NORM, kwargs...
    ) where {F, IN}
    autodiff = NonlinearSolveBase.select_jacobian_autodiff(prob, alg.autodiff)
    jac_cache = NonlinearSolveBase.construct_jacobian_cache(
        prob, solver, prob.f, fu, u, p; stats, autodiff, linsolve
    )
    J = alg.structure(reused_jacobian(jac_cache, u))
    return InitializedApproximateJacobianCache(
        J, alg.structure, alg, jac_cache, false, internalnorm
    )
end

function (cache::InitializedApproximateJacobianCache)(::TrueJacobianInitialization, fu, u)
    cache.J = cache.structure(cache.J, cache.cache(u))
    return
end

"""
    BroydenLowRankInitialization(alpha, threshold::Val)

An initialization for `LimitedMemoryBroyden` that uses a low rank approximation of the
Jacobian. The low rank updates to the Jacobian matrix corresponds to what SciPy calls
["simple"](https://docs.scipy.org/doc/scipy/reference/generated/scipy.optimize.broyden2.html#scipy-optimize-broyden2).
"""
@concrete struct BroydenLowRankInitialization <: AbstractJacobianInitialization
    alpha
    threshold <: Val
end

NonlinearSolveBase.jacobian_initialized_preinverted(::BroydenLowRankInitialization) = true

function InternalAPI.init(
        prob::AbstractNonlinearProblem, alg::BroydenLowRankInitialization,
        solver, f::F, fu, u, p;
        internalnorm::IN = L2_NORM, maxiters = 1000, verbose = NonlinearVerbosity(), kwargs...
    ) where {F, IN}
    if u isa Number # Use the standard broyden
        return InternalAPI.init(
            prob, IdentityInitialization(true, FullStructure()),
            solver, f, fu, u, p; internalnorm, maxiters, kwargs...
        )
    end

    if verbose isa Bool
        if verbose
            verbose = NonlinearVerbosity()
        else
            verbose = NonlinearVerbosity(None())
        end
    elseif verbose isa AbstractVerbosityPreset
        verbose = NonlinearVerbosity(verbose)
    end

    # Pay to cost of slightly more allocations to prevent type-instability for StaticArrays
    α = inv(Utils.initial_jacobian_scaling_alpha(alg.alpha, u, fu, internalnorm))
    if u isa StaticArray
        J = BroydenLowRankJacobian(fu, u; alg.threshold, alpha = α)
    else
        threshold = min(Utils.unwrap_val(alg.threshold), maxiters)
        if threshold > length(u)
            @SciMLMessage("`threshold` is larger than the size of the state, which may cause \
                   numerical instability. Consider reducing `threshold`.", verbose, :threshold_state)
        end
        J = BroydenLowRankJacobian(fu, u; threshold, alpha = α)
    end
    return InitializedApproximateJacobianCache(
        J, FullStructure(), alg, nothing, true, internalnorm
    )
end

function (cache::InitializedApproximateJacobianCache)(
        alg::BroydenLowRankInitialization, fu, u
    )
    α = Utils.initial_jacobian_scaling_alpha(alg.alpha, u, fu, cache.internalnorm)
    cache.J.idx = 0
    cache.J.alpha = inv(α)
    return
end

"""
    BroydenLowRankJacobian{T}(U, Vᵀ, idx, cache, alpha)

Low Rank Approximation of the Jacobian Matrix. Currently only used for
[`LimitedMemoryBroyden`](@ref). This computes the Jacobian as ``U \\times V^T``.
"""
@concrete mutable struct BroydenLowRankJacobian{T} <: AbstractSciMLOperator{T}
    U
    Vᵀ
    idx::Int
    cache
    alpha
end

Utils.maybe_pinv!!(workspace, A::BroydenLowRankJacobian) = A  # Already Inverted form

function get_components(op::BroydenLowRankJacobian)
    op.idx ≥ size(op.U, 2) && return op.cache, op.U, transpose(op.Vᵀ)
    cache = op.cache === nothing ? op.cache : view(op.cache, 1:(op.idx))
    return cache, view(op.U, :, 1:(op.idx)), transpose(view(op.Vᵀ, :, 1:(op.idx)))
end

Base.size(op::BroydenLowRankJacobian) = size(op.U, 1), size(op.Vᵀ, 1)

function Base.transpose(op::BroydenLowRankJacobian{T}) where {T}
    return BroydenLowRankJacobian{T}(op.Vᵀ, op.U, op.idx, op.cache, op.alpha)
end
Base.adjoint(op::BroydenLowRankJacobian{<:Real}) = transpose(op)

# Storing the transpose to ensure contiguous memory on splicing
function BroydenLowRankJacobian(
        fu::StaticArray, u::StaticArray; alpha = true, threshold::Val = Val(10)
    )
    T = promote_type(eltype(u), eltype(fu))
    U = MArray{Tuple{prod(Size(fu)), Utils.unwrap_val(threshold)}, T}(undef)
    Vᵀ = MArray{Tuple{prod(Size(u)), Utils.unwrap_val(threshold)}, T}(undef)
    return BroydenLowRankJacobian{T}(U, Vᵀ, 0, nothing, T(alpha))
end

function BroydenLowRankJacobian(fu, u; threshold::Int = 10, alpha = true)
    T = promote_type(eltype(u), eltype(fu))
    U = Utils.safe_similar(fu, T, length(fu), threshold)
    Vᵀ = Utils.safe_similar(u, T, length(u), threshold)
    cache = Utils.safe_similar(u, T, threshold)
    return BroydenLowRankJacobian{T}(U, Vᵀ, 0, cache, T(alpha))
end

function Base.:*(J::BroydenLowRankJacobian, x::AbstractVector)
    J.idx == 0 && return -x
    _, U, Vᵀ = get_components(J)
    return U * (Vᵀ * x) .- J.alpha .* x
end

function LinearAlgebra.mul!(y::AbstractVector, J::BroydenLowRankJacobian, x::AbstractVector)
    if J.idx == 0
        @. y = -J.alpha * x
        return y
    end
    cache, U, Vᵀ = get_components(J)
    @bb cache = Vᵀ × x
    LinearAlgebra.mul!(y, U, cache)
    @bb @. y -= J.alpha * x
    return y
end

function Base.:*(x::AbstractVector, J::BroydenLowRankJacobian)
    J.idx == 0 && return -x
    _, U, Vᵀ = get_components(J)
    return Vᵀ' * (U' * x) .- J.alpha .* x
end

function LinearAlgebra.mul!(y::AbstractVector, x::AbstractVector, J::BroydenLowRankJacobian)
    if J.idx == 0
        @. y = -J.alpha * x
        return y
    end
    cache, U, Vᵀ = get_components(J)
    @bb cache = transpose(U) × x
    LinearAlgebra.mul!(y, transpose(Vᵀ), cache)
    @bb @. y -= J.alpha * x
    return y
end

function LinearAlgebra.mul!(
        J::BroydenLowRankJacobian, u::AbstractArray, vᵀ::LinearAlgebra.AdjOrTransAbsVec,
        α::Bool, β::Bool
    )
    @assert α & β
    idx_update = mod1(J.idx + 1, size(J.U, 2))
    copyto!(@view(J.U[:, idx_update]), Utils.safe_vec(u))
    copyto!(@view(J.Vᵀ[:, idx_update]), Utils.safe_vec(vᵀ))
    J.idx += 1
    return J
end

ArrayInterface.restructure(::BroydenLowRankJacobian, J::BroydenLowRankJacobian) = J

"""
    LimitedMemoryBroyden(;
        max_resets::Int = 3, linesearch = nothing, threshold::Val = Val(10),
        reset_tolerance = nothing, alpha = nothing
    )

An implementation of `LimitedMemoryBroyden` [ziani2008autoadaptative](@cite) with resetting
and line search.

### Keyword Arguments

  - `max_resets`: the maximum number of resets to perform. Defaults to `3`.
  - `reset_tolerance`: the tolerance for the reset check. Defaults to
    `sqrt(eps(real(eltype(u))))`.
  - `threshold`: the number of vectors to store in the low rank approximation. Defaults
    to `Val(10)`.
  - `alpha`: The initial Jacobian inverse is set to be `(αI)⁻¹`. Defaults to `nothing`
    which implies `α = max(norm(u), 1) / (2 * norm(fu))`.
"""
function LimitedMemoryBroyden(;
        max_resets::Int = 3, linesearch = nothing, threshold::Union{Val, Int} = Val(10),
        reset_tolerance = nothing, alpha = nothing
    )
    threshold isa Int && (threshold = Val(threshold))
    return QuasiNewtonAlgorithm(;
        linesearch,
        descent = NewtonDescent(),
        update_rule = GoodBroydenUpdateRule(),
        max_resets,
        initialization = BroydenLowRankInitialization(alpha, threshold),
        reinit_rule = NoChangeInStateReset(; reset_tolerance),
        name = :LimitedMemoryBroyden,
        concrete_jac = Val(false)
    )
end

@testsetup module CoreRootfindTesting

include("../../../common/common_rootfind_testing.jl")

end

@testitem "Broyden" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, LineSearch
    using LineSearches: LineSearches
    using BenchmarkTools: @ballocated
    using StaticArrays: @SVector
    using Zygote, ForwardDiff, FiniteDiff

    # Conditionally import Enzyme only if not on Julia prerelease
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        using Enzyme
    end

    u0s = ([1.0, 1.0], @SVector[1.0, 1.0], 1.0)

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoZygote(), AutoFiniteDiff()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        @testset "$(nameof(typeof(linesearch)))" for linesearch in (
                # LineSearchesJL(; method = LineSearches.Static(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.BackTracking(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.MoreThuente(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.StrongWolfe(), autodiff = ad),
                LineSearchesJL(; method = LineSearches.HagerZhang(), autodiff = ad),
                BackTracking(; autodiff = ad),
                LiFukushimaLineSearch(),
            )
            @testset for init_jacobian in (Val(:identity), Val(:true_jacobian)),
                    update_rule in (Val(:good_broyden), Val(:bad_broyden), Val(:diagonal))

                @testset "[OOP] u0: $(typeof(u0))" for u0 in (
                        [1.0, 1.0], @SVector[1.0, 1.0], 1.0,
                    )
                    solver = Broyden(; linesearch, init_jacobian, update_rule)
                    sol = solve_oop(quadratic_f, u0; solver)
                    @test SciMLBase.successful_retcode(sol)
                    err = maximum(abs, quadratic_f(sol.u, 2.0))
                    @test err < 1.0e-9

                    cache = init(
                        NonlinearProblem{false}(quadratic_f, u0, 2.0), solver, abstol = 1.0e-9
                    )
                    @test (@ballocated solve!($cache)) < 200
                end

                @testset "[IIP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0],)
                    ad isa AutoZygote && continue

                    solver = Broyden(; linesearch, init_jacobian, update_rule)
                    sol = solve_iip(quadratic_f!, u0; solver)
                    @test SciMLBase.successful_retcode(sol)
                    err = maximum(abs, quadratic_f(sol.u, 2.0))
                    @test err < 1.0e-9

                    cache = init(
                        NonlinearProblem{true}(quadratic_f!, u0, 2.0), solver, abstol = 1.0e-9
                    )
                    @test (@ballocated solve!($cache)) ≤ 64
                end
            end
        end
    end
end

@testitem "Broyden: Iterator Interface" setup = [CoreRootfindTesting] tags = [:core] begin
    p = range(0.01, 2, length = 200)
    @test nlprob_iterator_interface(quadratic_f, p, false, Broyden()) ≈ sqrt.(p)
    @test nlprob_iterator_interface(quadratic_f!, p, true, Broyden()) ≈ sqrt.(p)
end

@testitem "Broyden Termination Conditions" setup = [CoreRootfindTesting] tags = [:core] begin
    using StaticArrays: @SVector

    @testset "TC: $(nameof(typeof(termination_condition)))" for termination_condition in
        TERMINATION_CONDITIONS

        @testset "u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            probN = NonlinearProblem(quadratic_f, u0, 2.0)
            sol = solve(probN, Broyden(); termination_condition)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end
end

@testitem "Klement" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, LineSearch
    using LineSearches: LineSearches
    using BenchmarkTools: @ballocated
    using StaticArrays: @SVector
    using Zygote, ForwardDiff, FiniteDiff

    # Conditionally import Enzyme only if not on Julia prerelease
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        using Enzyme
    end

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoZygote(), AutoFiniteDiff()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        @testset "$(nameof(typeof(linesearch)))" for linesearch in (
                # LineSearchesJL(; method = LineSearches.Static(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.BackTracking(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.MoreThuente(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.StrongWolfe(), autodiff = ad),
                LineSearchesJL(; method = LineSearches.HagerZhang(), autodiff = ad),
                BackTracking(; autodiff = ad),
                LiFukushimaLineSearch(),
            )
            @testset for init_jacobian in (
                    Val(:identity), Val(:true_jacobian), Val(:true_jacobian_diagonal),
                )
                @testset "[OOP] u0: $(typeof(u0))" for u0 in (
                        [1.0, 1.0], @SVector[1.0, 1.0], 1.0,
                    )
                    solver = Klement(; linesearch, init_jacobian)
                    sol = solve_oop(quadratic_f, u0; solver)
                    # XXX: some tests are failing by a margin
                    # @test SciMLBase.successful_retcode(sol)
                    err = maximum(abs, quadratic_f(sol.u, 2.0))
                    @test err < 1.0e-9

                    cache = init(
                        NonlinearProblem{false}(quadratic_f, u0, 2.0), solver, abstol = 1.0e-9
                    )
                    @test (@ballocated solve!($cache)) < 200
                end

                @testset "[IIP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0],)
                    ad isa AutoZygote && continue

                    solver = Klement(; linesearch, init_jacobian)
                    sol = solve_iip(quadratic_f!, u0; solver)
                    @test SciMLBase.successful_retcode(sol)
                    err = maximum(abs, quadratic_f(sol.u, 2.0))
                    @test err < 1.0e-9

                    cache = init(
                        NonlinearProblem{true}(quadratic_f!, u0, 2.0), solver, abstol = 1.0e-9
                    )
                    @test (@ballocated solve!($cache)) ≤ 64
                end
            end
        end
    end
end

@testitem "Klement: Iterator Interface" setup = [CoreRootfindTesting] tags = [:core] begin
    p = range(0.01, 2, length = 200)
    @test nlprob_iterator_interface(quadratic_f, p, false, Klement()) ≈ sqrt.(p)
    @test nlprob_iterator_interface(quadratic_f!, p, true, Klement()) ≈ sqrt.(p)
end

@testitem "Klement Termination Conditions" setup = [CoreRootfindTesting] tags = [:core] begin
    using StaticArrays: @SVector

    @testset "TC: $(nameof(typeof(termination_condition)))" for termination_condition in
        TERMINATION_CONDITIONS

        @testset "u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            probN = NonlinearProblem(quadratic_f, u0, 2.0)
            sol = solve(probN, Klement(); termination_condition)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end
end

@testitem "LimitedMemoryBroyden" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, LineSearch
    using LineSearches: LineSearches
    using BenchmarkTools: @ballocated
    using StaticArrays: @SVector
    using Zygote, ForwardDiff, FiniteDiff

    # Conditionally import Enzyme only if not on Julia prerelease
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        using Enzyme
    end

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoZygote(), AutoFiniteDiff()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        @testset "$(nameof(typeof(linesearch)))" for linesearch in (
                # LineSearchesJL(; method = LineSearches.Static(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.BackTracking(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.MoreThuente(), autodiff = ad),
                # LineSearchesJL(; method = LineSearches.StrongWolfe(), autodiff = ad),
                LineSearchesJL(; method = LineSearches.HagerZhang(), autodiff = ad),
                BackTracking(; autodiff = ad),
                LiFukushimaLineSearch(),
            )
            @testset "[OOP] u0: $(typeof(u0))" for u0 in (ones(32), @SVector(ones(2)), 1.0)
                broken = Sys.iswindows() && u0 isa Vector{Float64} &&
                    linesearch isa BackTracking && ad isa AutoFiniteDiff

                solver = LimitedMemoryBroyden(; linesearch)
                sol = solve_oop(quadratic_f, u0; solver)
                @test SciMLBase.successful_retcode(sol) broken = broken
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < 1.0e-9 broken = broken

                cache = init(
                    NonlinearProblem{false}(quadratic_f, u0, 2.0), solver, abstol = 1.0e-9
                )
                @test (@ballocated solve!($cache)) ≤ 400
            end

            @testset "[IIP] u0: $(typeof(u0))" for u0 in (ones(32),)
                ad isa AutoZygote && continue

                broken = Sys.iswindows() && u0 isa Vector{Float64} &&
                    linesearch isa BackTracking && ad isa AutoFiniteDiff

                solver = LimitedMemoryBroyden(; linesearch)
                sol = solve_iip(quadratic_f!, u0; solver)
                @test SciMLBase.successful_retcode(sol) broken = broken
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < 1.0e-9 broken = broken

                cache = init(
                    NonlinearProblem{true}(quadratic_f!, u0, 2.0), solver, abstol = 1.0e-9
                )
                @test (@ballocated solve!($cache)) ≤ 64
            end
        end
    end
end

@testitem "LimitedMemoryBroyden: Iterator Interface" setup = [CoreRootfindTesting] tags = [:core] begin
    p = range(0.01, 2, length = 200)
    @test nlprob_iterator_interface(quadratic_f, p, false, LimitedMemoryBroyden()) ≈
        sqrt.(p)
    @test nlprob_iterator_interface(quadratic_f!, p, true, LimitedMemoryBroyden()) ≈
        sqrt.(p)
end

@testitem "LimitedMemoryBroyden Termination Conditions" setup = [CoreRootfindTesting] tags = [:core] begin
    using StaticArrays: @SVector

    @testset "TC: $(nameof(typeof(termination_condition)))" for termination_condition in
        TERMINATION_CONDITIONS

        @testset "u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            probN = NonlinearProblem(quadratic_f, u0, 2.0)
            sol = solve(probN, LimitedMemoryBroyden(); termination_condition)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end
end

"""
    QuasiNewtonAlgorithm(;
        linesearch = missing, trustregion = missing, descent, update_rule, reinit_rule,
        initialization, max_resets::Int = typemax(Int), name::Symbol = :unknown,
        max_shrink_times::Int = typemax(Int), concrete_jac = Val(false)
    )

Nonlinear Solve Algorithms using an Iterative Approximation of the Jacobian. Most common
examples include [`Broyden`](@ref)'s Method.

### Keyword Arguments

  - `trustregion`: Globalization using a Trust Region Method. This needs to follow the
    [`NonlinearSolveBase.AbstractTrustRegionMethod`](@ref) interface.
  - `descent`: The descent method to use to compute the step. This needs to follow the
    [`NonlinearSolveBase.AbstractDescentDirection`](@ref) interface.
  - `max_shrink_times`: The maximum number of times the trust region radius can be shrunk
    before the algorithm terminates.
  - `update_rule`: The update rule to use to update the Jacobian. This needs to follow the
    [`NonlinearSolveBase.AbstractApproximateJacobianUpdateRule`](@ref) interface.
  - `reinit_rule`: The reinitialization rule to use to reinitialize the Jacobian. This
    needs to follow the [`NonlinearSolveBase.AbstractResetCondition`](@ref) interface.
  - `initialization`: The initialization method to use to initialize the Jacobian. This
    needs to follow the [`NonlinearSolveBase.AbstractJacobianInitialization`](@ref)
    interface.
"""
@concrete struct QuasiNewtonAlgorithm <: AbstractNonlinearSolveAlgorithm
    linesearch
    trustregion
    descent <: AbstractDescentDirection
    update_rule <: AbstractApproximateJacobianUpdateRule
    reinit_rule <: AbstractResetCondition
    initialization <: AbstractJacobianInitialization

    max_resets::Int
    max_shrink_times::Int

    concrete_jac <: Union{Val{false}, Val{true}}
    name::Symbol
end

function QuasiNewtonAlgorithm(;
        linesearch = missing, trustregion = missing, descent, update_rule, reinit_rule,
        initialization, max_resets::Int = typemax(Int), name::Symbol = :unknown,
        max_shrink_times::Int = typemax(Int), concrete_jac = Val(false)
    )
    return QuasiNewtonAlgorithm(
        linesearch, trustregion, descent, update_rule, reinit_rule, initialization,
        max_resets, max_shrink_times, concrete_jac, name
    )
end

@concrete mutable struct QuasiNewtonCache <: AbstractNonlinearSolveCache
    # Basic Requirements
    fu
    u
    u_cache
    p
    J   # Aliased to `initialization_cache.J` if !inverted_jac
    alg <: QuasiNewtonAlgorithm
    prob <: AbstractNonlinearProblem
    globalization <: Union{Val{:LineSearch}, Val{:TrustRegion}, Val{:None}}

    # Internal Caches
    initialization_cache
    descent_cache
    linesearch_cache
    trustregion_cache
    update_rule_cache
    reinit_rule_cache

    inv_workspace

    # Counters
    stats::NLStats
    nsteps::Int
    nresets::Int
    max_resets::Int
    maxiters::Int
    maxtime
    max_shrink_times::Int
    steps_since_last_reset::Int

    # Timer
    timer
    total_time::Float64

    # Termination & Tracking
    termination_cache
    trace
    retcode::ReturnCode.T
    force_stop::Bool
    force_reinit::Bool
    kwargs

    # Initialization
    initializealg

    verbose
end

function SciMLBase.get_du(cache::QuasiNewtonCache)
    return SciMLBase.get_du(cache.descent_cache)
end
function NonlinearSolveBase.set_du!(cache::QuasiNewtonCache, δu)
    return NonlinearSolveBase.set_du!(cache.descent_cache, δu)
end

function NonlinearSolveBase.get_abstol(cache::QuasiNewtonCache)
    return NonlinearSolveBase.get_abstol(cache.termination_cache)
end
function NonlinearSolveBase.get_reltol(cache::QuasiNewtonCache)
    return NonlinearSolveBase.get_reltol(cache.termination_cache)
end

function InternalAPI.reinit_self!(
        cache::QuasiNewtonCache, args...; p = cache.p, u0 = cache.u,
        alias_u0::Bool = hasproperty(cache, :alias_u0) ? cache.alias_u0 : false,
        maxiters = hasproperty(cache, :maxiters) ? cache.maxiters : 1000,
        maxtime = hasproperty(cache, :maxtime) ? cache.maxtime : nothing, kwargs...
    )
    Utils.reinit_common!(cache, u0, p, alias_u0)

    InternalAPI.reinit!(cache.stats)
    cache.nsteps = 0
    cache.nresets = 0
    cache.steps_since_last_reset = 0
    cache.maxiters = maxiters
    cache.maxtime = maxtime
    cache.total_time = 0.0
    cache.force_stop = false
    cache.force_reinit = false
    cache.retcode = ReturnCode.Default

    NonlinearSolveBase.reset!(cache.trace)
    SciMLBase.reinit!(
        cache.termination_cache, NonlinearSolveBase.get_fu(cache),
        NonlinearSolveBase.get_u(cache); kwargs...
    )
    NonlinearSolveBase.reset_timer!(cache.timer)
    return
end

NonlinearSolveBase.@internal_caches(
    QuasiNewtonCache,
    :initialization_cache, :descent_cache, :linesearch_cache, :trustregion_cache,
    :update_rule_cache, :reinit_rule_cache
)

function SciMLBase.__init(
        prob::AbstractNonlinearProblem, alg::QuasiNewtonAlgorithm, args...;
        stats = NLStats(0, 0, 0, 0, 0), alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false), maxtime = nothing,
        maxiters = 1000, abstol = nothing, reltol = nothing,
        linsolve_kwargs = (;), termination_condition = nothing,
        internalnorm::F = L2_NORM, initializealg = NonlinearSolveBase.NonlinearSolveDefaultInit(),
        verbose = NonlinearVerbosity(),
        kwargs...
    ) where {F}
    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    # Enzyme cannot differentiate through FunctionWrappers' llvmcall.
    # QuasiNewton doesn't have alg.autodiff fields; autodiff may come through kwargs
    # or from the linesearch/trustregion algorithm's own autodiff field.
    _ls_ad = if alg.linesearch !== missing && alg.linesearch !== nothing &&
            hasfield(typeof(alg.linesearch), :autodiff)
        alg.linesearch.autodiff
    else
        nothing
    end
    _tr_ad = if alg.trustregion !== missing && alg.trustregion !== nothing &&
            hasfield(typeof(alg.trustregion), :autodiff)
        alg.trustregion.autodiff
    else
        nothing
    end
    _ad_prob = NonlinearSolveBase.maybe_unwrap_prob_for_enzyme(
        prob,
        get(kwargs, :autodiff, nothing),
        get(kwargs, :jvp_autodiff, nothing),
        get(kwargs, :vjp_autodiff, nothing),
        _ls_ad,
        _tr_ad,
    )

    timer = get_timer_output()
    @static_timeit timer "cache construction" begin

        if verbose isa Bool
            if verbose
                verbose = NonlinearVerbosity()
            else
                verbose = NonlinearVerbosity(None())
            end
        elseif verbose isa AbstractVerbosityPreset
            verbose = NonlinearVerbosity(verbose)
        end

        u = Utils.maybe_unaliased(prob.u0, alias_u0)
        fu = Utils.evaluate_f(prob, u)
        @bb u_cache = copy(u)

        inverted_jac = NonlinearSolveBase.store_inverse_jacobian(alg.update_rule)

        linsolve = NonlinearSolveBase.get_linear_solver(alg.descent)

        initialization_cache = InternalAPI.init(
            prob, alg.initialization, alg, prob.f, fu, u, prob.p;
            stats, linsolve, maxiters, internalnorm
        )

        abstol, reltol,
            termination_cache = NonlinearSolveBase.init_termination_cache(
            prob, abstol, reltol, fu, u, termination_condition, Val(:regular)
        )
        linsolve_kwargs = merge((; verbose = verbose.linear_verbosity, abstol, reltol), linsolve_kwargs)

        J = initialization_cache(nothing)

        inv_workspace,
            J = Utils.unwrap_val(inverted_jac) ?
            Utils.maybe_pinv!!_workspace(J) : (nothing, J)

        descent_cache = InternalAPI.init(
            prob, alg.descent, J, fu, u;
            stats, abstol, reltol, internalnorm,
            linsolve_kwargs, pre_inverted = inverted_jac, timer
        )
        du = SciMLBase.get_du(descent_cache)

        reinit_rule_cache = InternalAPI.init(alg.reinit_rule, J, fu, u, du)

        has_linesearch = alg.linesearch !== missing && alg.linesearch !== nothing
        has_trustregion = alg.trustregion !== missing && alg.trustregion !== nothing

        if has_trustregion && has_linesearch
            error("TrustRegion and LineSearch methods are algorithmically incompatible.")
        end

        globalization = Val(:None)
        linesearch_cache = nothing
        trustregion_cache = nothing

        if has_trustregion
            NonlinearSolveBase.supports_trust_region(alg.descent) ||
                error("Trust Region not supported by $(alg.descent).")
            trustregion_cache = InternalAPI.init(
                _ad_prob, alg.trustregion, fu, u, _ad_prob.p; stats, internalnorm, kwargs...
            )
            globalization = Val(:TrustRegion)
        end

        if has_linesearch
            NonlinearSolveBase.supports_line_search(alg.descent) ||
                error("Line Search not supported by $(alg.descent).")
            _ls_ad = NonlinearSolveBase.standardize_forwarddiff_tag(
                _ls_ad, _ad_prob
            )
            linesearch_cache = CommonSolve.init(
                _ad_prob, alg.linesearch, fu, u;
                stats, internalnorm, autodiff = _ls_ad, kwargs...
            )
            globalization = Val(:LineSearch)
        end

        update_rule_cache = InternalAPI.init(
            prob, alg.update_rule, J, fu, u, du; stats, internalnorm
        )

        trace = NonlinearSolveBase.init_nonlinearsolve_trace(
            prob, alg, u, fu, J, du;
            uses_jacobian_inverse = inverted_jac, kwargs...
        )

        cache = QuasiNewtonCache(
            fu, u, u_cache, prob.p, J, alg, prob, globalization,
            initialization_cache, descent_cache, linesearch_cache,
            trustregion_cache, update_rule_cache, reinit_rule_cache,
            inv_workspace, stats, 0, 0, alg.max_resets, maxiters, maxtime,
            alg.max_shrink_times, 0, timer, 0.0, termination_cache, trace,
            ReturnCode.Default, false, false, kwargs, initializealg, verbose
        )
        NonlinearSolveBase.run_initialization!(cache)
    end

    return cache
end

function InternalAPI.step!(
        cache::QuasiNewtonCache; recompute_jacobian::Union{Nothing, Bool} = nothing
    )
    new_jacobian = true
    @static_timeit cache.timer "jacobian init/reinit" begin
        if cache.nsteps == 0  # First Step is special ignore kwargs
            J_init = InternalAPI.solve!(
                cache.initialization_cache, cache.fu, cache.u, Val(false)
            )
            if Utils.unwrap_val(NonlinearSolveBase.store_inverse_jacobian(cache.update_rule_cache))
                if NonlinearSolveBase.jacobian_initialized_preinverted(
                        cache.initialization_cache.alg
                    )
                    cache.J = J_init
                else
                    cache.J = Utils.maybe_pinv!!(cache.inv_workspace, J_init)
                end
            else
                if NonlinearSolveBase.jacobian_initialized_preinverted(
                        cache.initialization_cache.alg
                    )
                    cache.J = Utils.maybe_pinv!!(cache.inv_workspace, J_init)
                else
                    cache.J = J_init
                end
            end
            J = cache.J
            cache.steps_since_last_reset += 1
        else
            countable_reinit = false
            if cache.force_reinit
                reinit, countable_reinit = true, true
                cache.force_reinit = false
            elseif recompute_jacobian === nothing
                # Standard Step
                reinit = InternalAPI.solve!(
                    cache.reinit_rule_cache, cache.J, cache.fu, cache.u, SciMLBase.get_du(cache)
                )
                reinit && (countable_reinit = true)
            elseif recompute_jacobian
                reinit = true  # Force ReInitialization: Don't count towards resetting
            else
                new_jacobian = false # Jacobian won't be updated in this step
                reinit = false       # Override Checks: Unsafe operation
            end

            if countable_reinit
                cache.nresets += 1
                if cache.nresets ≥ cache.max_resets
                    cache.retcode = ReturnCode.ConvergenceFailure
                    cache.force_stop = true
                    return
                end
            end

            if reinit
                J_init = InternalAPI.solve!(
                    cache.initialization_cache, cache.fu, cache.u, Val(true)
                )
                cache.J = Utils.unwrap_val(NonlinearSolveBase.store_inverse_jacobian(cache.update_rule_cache)) ?
                    Utils.maybe_pinv!!(cache.inv_workspace, J_init) : J_init
                J = cache.J
                cache.steps_since_last_reset = 0
            else
                J = cache.J
                cache.steps_since_last_reset += 1
            end
        end
    end

    @static_timeit cache.timer "descent" begin
        if cache.trustregion_cache !== nothing &&
                hasfield(typeof(cache.trustregion_cache), :trust_region)
            descent_result = InternalAPI.solve!(
                cache.descent_cache, J, cache.fu, cache.u; new_jacobian,
                cache.trustregion_cache.trust_region, cache.kwargs...
            )
        else
            descent_result = InternalAPI.solve!(
                cache.descent_cache, J, cache.fu, cache.u; new_jacobian, cache.kwargs...
            )
        end
    end

    if !descent_result.linsolve_success
        if new_jacobian && cache.steps_since_last_reset == 0
            # Extremely pathological case. Jacobian was just reset and linear solve
            # failed. Should ideally never happen in practice unless true jacobian init
            # is used.
            cache.retcode = ReturnCode.InternalLinearSolveFailed
            cache.force_stop = true
            return
        else
            # Force a reinit because the problem is currently un-solvable

            @SciMLMessage("Linear Solve Failed but Jacobian information is not current. Retrying with updated Jacobian. \
                Retrying with updated Jacobian.", cache.verbose, :linsolve_failed_noncurrent)

            cache.force_reinit = true
            InternalAPI.step!(cache; recompute_jacobian = true)
            return
        end
    end

    δu, descent_intermediates = descent_result.δu, descent_result.extras

    if descent_result.success
        if cache.globalization isa Val{:LineSearch}
            @static_timeit cache.timer "linesearch" begin
                linesearch_sol = CommonSolve.solve!(cache.linesearch_cache, cache.u, δu)
                needs_reset = !SciMLBase.successful_retcode(linesearch_sol.retcode)
                α = linesearch_sol.step_size
            end
            if needs_reset && cache.steps_since_last_reset > 5 # Reset after a burn-in period
                cache.force_reinit = true
            else
                @static_timeit cache.timer "step" begin
                    @bb axpy!(α, δu, cache.u)
                    Utils.evaluate_f!(cache, cache.u, cache.p)
                end
            end
        elseif cache.globalization isa Val{:TrustRegion}
            @static_timeit cache.timer "trustregion" begin
                tr_accepted, u_new,
                    fu_new = InternalAPI.solve!(
                    cache.trustregion_cache, J, cache.fu, cache.u, δu, descent_intermediates
                )
                if tr_accepted
                    @bb copyto!(cache.u, u_new)
                    @bb copyto!(cache.fu, fu_new)
                end
                if hasfield(typeof(cache.trustregion_cache), :shrink_counter) &&
                        cache.trustregion_cache.shrink_counter > cache.max_shrink_times
                    cache.retcode = ReturnCode.ShrinkThresholdExceeded
                    cache.force_stop = true
                end
            end
            α = true
        elseif cache.globalization isa Val{:None}
            @static_timeit cache.timer "step" begin
                @bb axpy!(1, δu, cache.u)
                Utils.evaluate_f!(cache, cache.u, cache.p)
            end
            α = true
        else
            error("Unknown Globalization Strategy: $(cache.globalization). Allowed values \
                   are (:LineSearch, :TrustRegion, :None)")
        end

        NonlinearSolveBase.check_and_update!(cache, cache.fu, cache.u, cache.u_cache)
    else
        α = false
        cache.force_reinit = true
    end

    update_trace!(
        cache, α;
        uses_jac_inverse = NonlinearSolveBase.store_inverse_jacobian(cache.update_rule_cache)
    )
    @bb copyto!(cache.u_cache, cache.u)

    if (
            cache.force_stop || cache.force_reinit ||
                (recompute_jacobian !== nothing && !recompute_jacobian)
        )
        NonlinearSolveBase.callback_into_cache!(cache)
        return nothing
    end

    @static_timeit cache.timer "jacobian update" begin
        cache.J = InternalAPI.solve!(
            cache.update_rule_cache, cache.J, cache.fu, cache.u, δu
        )
        NonlinearSolveBase.callback_into_cache!(cache)
    end

    return nothing
end

"""
    DiagonalStructure()

Preserves only the Diagonal of the Matrix.
"""
struct DiagonalStructure <: AbstractApproximateJacobianStructure end

NonlinearSolveBase.get_full_jacobian(cache, ::DiagonalStructure, J::Number) = J
function NonlinearSolveBase.get_full_jacobian(cache, ::DiagonalStructure, J)
    return Diagonal(Utils.safe_vec(J))
end

function (::DiagonalStructure)(J::AbstractMatrix; alias::Bool = false)
    @assert size(J, 1) == size(J, 2) "Diagonal Jacobian Structure must be square!"
    return LinearAlgebra.diag(J)
end
(::DiagonalStructure)(J::AbstractVector; alias::Bool = false) = alias ? J : @bb(copy(J))
(::DiagonalStructure)(J::Number; alias::Bool = false) = J

(::DiagonalStructure)(::Number, J_new::Number) = J_new
function (::DiagonalStructure)(J::AbstractVector, J_new::AbstractMatrix)
    if ArrayInterface.can_setindex(J)
        if ArrayInterface.fast_scalar_indexing(J)
            @simd ivdep for i in eachindex(J)
                @inbounds J[i] = J_new[i, i]
            end
        else
            J .= @view(J_new[diagind(J_new)])
        end
        return J
    end
    return LinearAlgebra.diag(J_new)
end
function (st::DiagonalStructure)(J::AbstractArray, J_new::AbstractMatrix)
    return ArrayInterface.restructure(J, st(vec(J), J_new))
end

"""
    FullStructure()

Stores the full matrix.
"""
struct FullStructure <: AbstractApproximateJacobianStructure end

NonlinearSolveBase.stores_full_jacobian(::FullStructure) = true

(::FullStructure)(J; alias::Bool = false) = alias ? J : @bb(copy(J))

function (::FullStructure)(J, J_new)
    J === J_new && return J
    @bb copyto!(J, J_new)
    return J
end

"""
    Klement(;
        max_resets = 100, linsolve = nothing, linesearch = nothing,
        alpha = nothing, init_jacobian::Val = Val(:identity),
        autodiff = nothing
    )

An implementation of `Klement` [klement2014using](@citep) with line search, preconditioning
and customizable linear solves. It is recommended to use [`Broyden`](@ref) for most problems
over this.

### Keyword Arguments

  - `max_resets`: the maximum number of resets to perform. Defaults to `100`.

  - `alpha`: If `init_jacobian` is set to `Val(:identity)`, then the initial Jacobian
    inverse is set to be `αI`. Defaults to `1`. Can be set to `nothing` which implies
    `α = max(norm(u), 1) / (2 * norm(fu))`.
  - `init_jacobian`: the method to use for initializing the jacobian. Defaults to
    `Val(:identity)`. Choices include:

      + `Val(:identity)`: Identity Matrix.
      + `Val(:true_jacobian)`: True Jacobian. Our tests suggest that this is not very
        stable. Instead using `Broyden` with `Val(:true_jacobian)` gives faster and more
        reliable convergence.
      + `Val(:true_jacobian_diagonal)`: Diagonal of True Jacobian. This is a good choice for
        differentiable problems.
"""
function Klement(;
        max_resets = 100, linsolve = nothing, linesearch = nothing,
        alpha = nothing, init_jacobian::Val = Val(:identity),
        autodiff = nothing
    )
    concrete_jac = Val(
        init_jacobian isa Val{:true_jacobian} ||
            init_jacobian isa Val{:true_jacobian_diagonal}
    )
    return QuasiNewtonAlgorithm(;
        linesearch,
        descent = NewtonDescent(; linsolve),
        update_rule = KlementUpdateRule(),
        reinit_rule = IllConditionedJacobianReset(),
        max_resets,
        initialization = klement_init(init_jacobian, autodiff, alpha),
        concrete_jac,
        name = :Klement
    )
end

function klement_init(::Val{:identity}, autodiff, alpha)
    return IdentityInitialization(alpha, DiagonalStructure())
end
function klement_init(::Val{:true_jacobian}, autodiff, alpha)
    return TrueJacobianInitialization(FullStructure(), autodiff)
end
function klement_init(::Val{:true_jacobian_diagonal}, autodiff, alpha)
    return TrueJacobianInitialization(DiagonalStructure(), autodiff)
end
function klement_init(::Val{IJ}, autodiff, alpha) where {IJ}
    error("Unknown `init_jacobian = Val($(Meta.quot(IJ)))`. Please choose a valid \
           `init_jacobian`.")
end

"""
    KlementUpdateRule()

Update rule for [`Klement`](@ref).
"""
struct KlementUpdateRule <: AbstractApproximateJacobianUpdateRule end

function Base.getproperty(rule::KlementUpdateRule, sym::Symbol)
    sym == :store_inverse_jacobian && return Val(false)
    return getfield(rule, sym)
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem, alg::KlementUpdateRule,
        J, fu, u, du, args...; kwargs...
    )
    @bb Jdu = similar(fu)
    if J isa Diagonal || J isa Number
        J_cache, J_cache_2, Jdu_cache = nothing, nothing, nothing
    else
        @bb J_cache = similar(J)
        @bb J_cache_2 = similar(J)
        @bb Jdu_cache = similar(Jdu)
    end
    @bb fu_cache = copy(fu)
    return KlementUpdateRuleCache(Jdu, J_cache, J_cache_2, Jdu_cache, fu_cache, alg)
end

@concrete mutable struct KlementUpdateRuleCache <:
    AbstractApproximateJacobianUpdateRuleCache
    Jdu
    J_cache
    J_cache_2
    Jdu_cache
    fu_cache
    rule <: KlementUpdateRule
end

function InternalAPI.solve!(
        cache::KlementUpdateRuleCache, J::Number, fu, u, du; kwargs...
    )
    Jdu = J^2 * du^2
    J = J + ((fu - cache.fu_cache - J * du) / ifelse(iszero(Jdu), 1.0e-5, Jdu)) * du * J^2
    cache.fu_cache = fu
    return J
end

function InternalAPI.solve!(
        cache::KlementUpdateRuleCache, J::Diagonal, fu, u, du; kwargs...
    )
    T = eltype(u)
    J = Utils.restructure(u, diag(J))
    @bb @. cache.Jdu = (J^2) * (du^2)
    @bb @. J += (
        (fu - cache.fu_cache - J * du) /
            ifelse(iszero(cache.Jdu), T(1.0e-5), cache.Jdu)
    ) * du * (J^2)
    @bb copyto!(cache.fu_cache, fu)
    return Diagonal(vec(J))
end

function InternalAPI.solve!(
        cache::KlementUpdateRuleCache, J::AbstractMatrix, fu, u, du; kwargs...
    )
    T = eltype(u)
    @bb @. cache.J_cache = J'^2
    @bb @. cache.Jdu = du^2
    @bb cache.Jdu_cache = cache.J_cache × vec(cache.Jdu)
    @bb cache.Jdu = J × vec(du)
    @bb @. cache.fu_cache = (fu - cache.fu_cache - cache.Jdu) /
        ifelse(iszero(cache.Jdu_cache), T(1.0e-5), cache.Jdu_cache)
    @bb cache.J_cache = vec(cache.fu_cache) × transpose(Utils.safe_vec(du))
    @bb @. cache.J_cache *= J
    @bb cache.J_cache_2 = cache.J_cache × J
    @bb J .+= cache.J_cache_2
    @bb copyto!(cache.fu_cache, fu)
    return J
end

module NonlinearSolveQuasiNewton

using ConcreteStructs: @concrete
using PrecompileTools: @compile_workload, @setup_workload
using Reexport: @reexport

using ArrayInterface: ArrayInterface
using StaticArraysCore: StaticArray, Size, MArray

using CommonSolve: CommonSolve
using LinearAlgebra: LinearAlgebra, Diagonal, dot, diag
using LinearSolve: LinearSolve # Trigger Linear Solve extension in NonlinearSolveBase
using MaybeInplace: @bb
using NonlinearSolveBase: NonlinearSolveBase, AbstractNonlinearSolveAlgorithm,
    AbstractNonlinearSolveCache, AbstractResetCondition,
    AbstractResetConditionCache, AbstractApproximateJacobianStructure,
    AbstractJacobianCache, AbstractJacobianInitialization,
    AbstractApproximateJacobianUpdateRule, AbstractDescentDirection,
    AbstractApproximateJacobianUpdateRuleCache,
    Utils, InternalAPI, get_timer_output, @static_timeit,
    update_trace!, L2_NORM, NewtonDescent, NonlinearVerbosity,
    @SciMLMessage, None, AbstractVerbosityPreset, reused_jacobian
using SciMLBase: SciMLBase, AbstractNonlinearProblem, NLStats, ReturnCode,
    NonlinearProblem, NonlinearFunction, NoSpecialize
using SciMLOperators: AbstractSciMLOperator

include("reset_conditions.jl")
include("structure.jl")
include("initialization.jl")

include("broyden.jl")
include("lbroyden.jl")
include("klement.jl")

include("solve.jl")

@setup_workload begin
    nonlinear_functions = (
        (NonlinearFunction{false, NoSpecialize}((u, p) -> u .* u .- p), 0.1),
        (NonlinearFunction{false, NoSpecialize}((u, p) -> u .* u .- p), [0.1]),
        (NonlinearFunction{true, NoSpecialize}((du, u, p) -> du .= u .* u .- p), [0.1]),
    )

    nonlinear_problems = NonlinearProblem[]
    for (fn, u0) in nonlinear_functions
        push!(nonlinear_problems, NonlinearProblem(fn, u0, 2.0))
    end

    algs = [Broyden(), Klement()]

    @compile_workload begin
        @sync for prob in nonlinear_problems, alg in algs

            Threads.@spawn CommonSolve.solve(prob, alg; abstol = 1.0e-2, verbose = false)
        end
    end
end

@reexport using SciMLBase, NonlinearSolveBase

export Broyden, LimitedMemoryBroyden, Klement, QuasiNewtonAlgorithm

end

"""
    NoChangeInStateReset(;
        nsteps::Int = 3, reset_tolerance = nothing,
        check_du::Bool = true, check_dfu::Bool = true
    )

Recommends a reset if the state or the function value has not changed significantly in
`nsteps` steps. This is used in [`Broyden`](@ref).

### Keyword Arguments

  - `nsteps`: the number of steps to check for no change. Defaults to `3`.
  - `reset_tolerance`: the tolerance for the reset check. Defaults to
    `eps(real(eltype(u)))^(3 // 4)`.
  - `check_du`: whether to check the state. Defaults to `true`.
  - `check_dfu`: whether to check the function value. Defaults to `true`.
"""
@kwdef @concrete struct NoChangeInStateReset <: AbstractResetCondition
    nsteps::Int = 3
    reset_tolerance = nothing
    check_du::Bool = true
    check_dfu::Bool = true
end

function InternalAPI.init(
        condition::NoChangeInStateReset, J, fu, u, du, args...; kwargs...
    )
    if condition.check_dfu
        @bb dfu = copy(fu)
    else
        dfu = fu
    end
    T = real(eltype(u))
    tol = condition.reset_tolerance === nothing ? eps(T)^(3 // 4) :
        T(condition.reset_tolerance)
    return NoChangeInStateResetCache(dfu, tol, condition, 0, 0)
end

@concrete mutable struct NoChangeInStateResetCache <: AbstractResetConditionCache
    dfu
    reset_tolerance
    condition <: NoChangeInStateReset
    steps_since_change_du::Int
    steps_since_change_dfu::Int
end

function InternalAPI.reinit!(cache::NoChangeInStateResetCache; u0 = nothing, kwargs...)
    if u0 !== nothing && cache.condition.reset_tolerance === nothing
        cache.reset_tolerance = eps(real(eltype(u0)))^(3 // 4)
    end
    cache.steps_since_change_dfu = 0
    return cache.steps_since_change_du = 0
end

function InternalAPI.solve!(cache::NoChangeInStateResetCache, J, fu, u, du; kwargs...)
    cond = ≤(cache.reset_tolerance) ∘ abs
    if cache.condition.check_du
        if any(cond, du)
            cache.steps_since_change_du += 1
            if cache.steps_since_change_du ≥ cache.condition.nsteps
                cache.steps_since_change_du = 0
                cache.steps_since_change_dfu = 0
                return true
            end
        else
            cache.steps_since_change_du = 0
            cache.steps_since_change_dfu = 0
        end
    end
    if cache.condition.check_dfu
        @bb @. cache.dfu = fu - cache.dfu
        if any(cond, cache.dfu)
            cache.steps_since_change_dfu += 1
            if cache.steps_since_change_dfu ≥ cache.condition.nsteps
                cache.steps_since_change_dfu = 0
                cache.steps_since_change_du = 0
                @bb copyto!(cache.dfu, fu)
                return true
            end
        else
            cache.steps_since_change_dfu = 0
            cache.steps_since_change_du = 0
        end
        @bb copyto!(cache.dfu, fu)
    end
    return false
end

"""
    IllConditionedJacobianReset()

Recommend resetting the Jacobian if the current jacobian is ill-conditioned. This is used
in [`Klement`](@ref).
"""
struct IllConditionedJacobianReset <: AbstractResetCondition end

function InternalAPI.init(
        condition::IllConditionedJacobianReset, J, fu, u, du, args...; kwargs...
    )
    condition_number_threshold = J isa AbstractMatrix ? inv(eps(real(eltype(J))))^(1 // 2) :
        nothing
    return IllConditionedJacobianResetCache(condition_number_threshold)
end

@concrete struct IllConditionedJacobianResetCache <: AbstractResetConditionCache
    condition_number_threshold
end

# NOTE: we don't need a reinit! since we establish the threshold based on the eltype

function InternalAPI.solve!(
        cache::IllConditionedJacobianResetCache, J, fu, u, du; kwargs...
    )
    J isa Number && return iszero(J)
    J isa Diagonal && return any(iszero, diag(J))
    J isa AbstractVector && return any(iszero, J)
    J isa AbstractMatrix &&
        return Utils.condition_number(J) ≥ cache.condition_number_threshold
    return false
end
